package com.realnet.basic.Services;
import com.realnet.basic.Repository.ProjectsRepository;
import com.realnet.basic.Entity.Projects
;import java.util.*;

import org.springframework.beans.factory.annotation.Autowired;
import com.realnet.SequenceGenerator.Service.SequenceService;
import org.springframework.data.domain.Page;
import com.realnet.realm.Entity.Realm;
import com.realnet.realm.Services.RealmService;
import org.springframework.data.domain.Pageable;
import org.springframework.http.*;
import com.realnet.users.service1.AppUserServiceImpl;
import com.realnet.users.entity1.AppUser;


import com.realnet.basic.Entity.Clients;
import com.realnet.basic.Services.ClientsService;









	import org.springframework.stereotype.Service;

@Service
 public class ProjectsService {
@Autowired
private ProjectsRepository Repository;
	@Autowired
	private AppUserServiceImpl userService; 
@Autowired
	private RealmService realmService;

@Autowired
	private ClientsService select_clientserv;







public Projects Savedata(Projects data) {



 
if (data.getSelect_client() != null) {
		try {	
  int select_clientId = Integer.valueOf(data.getSelect_client());
Clients get =  select_clientserv.getdetailsbyId(select_clientId);
			if (get != null) {

			data.setSelect_clientname(get.getClient_name());
}
} catch (NumberFormatException e) {
				System.out.println(" select_clientId is not integer..");
				// Invalid integer string — ignore or log
			}

		}

 








	data.setUpdatedBy(getUser().getUserId());
		data.setCreatedBy(getUser().getUserId());
		data.setAccountId(getUser().getAccount().getAccount_id());
Projects save = Repository.save(data);
				return save;	
			}


//	get all with pagination
	public Page<Projects> getAllWithPagination(Pageable page) {
		return Repository.findAll(page, getUser().getUserId());
	}			
public List<Projects> getdetails() {  
		List<Realm> realm = realmService.findByUserId(getUser().getUserId());
List<Projects> all = Repository.findAll(getUser().getUserId());
		
		return all ;		}


public Projects getdetailsbyId(Integer id) {
	return Repository.findById(id).get();
			}


	public void delete_by_id(Integer id) {
 Repository.deleteById(id);
}


public Projects update(Projects data,Integer id) {
	Projects old = Repository.findById(id).get();
old.setProject_name(data.getProject_name());

old.setSelect_client(data.getSelect_client());

old.setProject_description(data.getProject_description());

old.setHourly_rate(data.getHourly_rate());

old.setEstimated_hours(data.getEstimated_hours());

final Projects test = Repository.save(old);
		data.setUpdatedBy(getUser().getUserId());
  return test;} 










 public AppUser getUser() {
		AppUser user = userService.getLoggedInUser();
		return user;

	}}
